<!--实验室统计列表-->
<template>
  <div class="laboratoryStatistics">
    <el-form :model="queryParams" class="form-box" ref="queryForm" :inline="true">
      <el-form-item label="" prop="deptId" label-width="50px">
        <el-select v-model="queryParams.deptId" clearable placeholder="全部">
          <el-option
            v-for="item in deptSelectList"
            :key="item.deptId"
            :label="item.deptName"
            :value="item.deptId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="" prop="typeId">
        <el-select v-model="queryParams.typeId" clearable placeholder="安全分类" style="width: 120px">
          <el-option
            v-for="item in classTypeList"
            :key="item.id"
            :label="item.typeName"
            :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="" prop="level">
        <el-select v-model="queryParams.level" clearable placeholder="安全分级" style="width: 120px">
          <el-option
            v-for="item in classifiedList"
            :key="item.id"
            :label="item.classifiedName"
            :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="" prop="searchValue" label-width="80px">
        <el-input
          maxLength="30"
          v-model="queryParams.searchValue"
          placeholder="实验室/房间号"
          clearable
          style="width: 200px"/>
      </el-form-item>
      <!--<el-form-item label="" prop="dateRange" label-width="70px">-->
        <!--<el-date-picker-->
          <!--:clearable="false"-->
          <!--v-model="dateRange"-->
          <!--size="small"-->
          <!--style="width: 240px"-->
          <!--value-format="yyyy-MM-dd"-->
          <!--type="daterange"-->
          <!--range-separator="-"-->
          <!--start-placeholder="开始日期"-->
          <!--end-placeholder="结束日期"-->
        <!--&gt;</el-date-picker>-->
      <!--</el-form-item>-->
      <el-form-item>
        <p class="inquire-button-one" @click="handleQuery" style="margin-right:10px;">查询</p>
        <p class="reset-button-one" @click="resetQuery">重置</p>
      </el-form-item>
      <el-form-item style="float: right;" v-hasPermi="['safety:dataSub:export']">
        <el-dropdown @command="exportButton">
          <div class="form-dropdown-box">
            <img src="@/assets/ZDimages/personnelManagement/icon_jzgxx_sc.png">
            <p>导出</p>
            <img src="@/assets/ZDimages/personnelManagement/icon_jzggl_xljt.png">
          </div>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item style="border-bottom:1px solid #E0E0E0;margin:0 10px;color:#333;" :command="{command:1}">导出全部数据</el-dropdown-item>
            <el-dropdown-item style="margin:0 10px;color:#333;" :command="{command:2}">导出选中数据</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </el-form-item>
    </el-form>
    <div class="num-data-box">
      搜索到实验室总数 {{numData.sumTotal}}，存在危险源的实验室数 {{numData.hazardSubjectTotal}}，危险源总数 {{numData.hazardTotal}}<span v-for="item in numData.classListVo">，{{item.levelName}} {{item.amount}}</span>
    </div>
    <el-table  border :data="tableList" ref="multipleTable"
               :row-key="getRowKeys"
               @select="select" @select-all="selectAll">
      <el-table-column type="selection" width="50" align="center" fixed/>
      <el-table-column label="序号" align="center"  type="index" width="60" fixed/>
      <el-table-column label="学院" align="center" prop="collegeName" show-overflow-tooltip width="200" fixed/>
      <el-table-column label="实验室" align="center" prop="subjectName" show-overflow-tooltip width="180" fixed/>
      <el-table-column label="房间号" align="center" prop="roomNumber" show-overflow-tooltip width="100"/>
      <el-table-column label="楼栋" align="center" prop="buildName" show-overflow-tooltip width="180"/>
      <el-table-column label="安全分类" align="center" prop="typeName" show-overflow-tooltip width="100"/>
      <el-table-column label="安全分级" align="center" prop="levelName" show-overflow-tooltip width="100"/>
      <el-table-column label="危险源" align="center" prop="hazardName" show-overflow-tooltip width="260"/>
      <el-table-column label="实验室安全责任人" align="center" prop="safeUserNameAdminPhone" show-overflow-tooltip width="185"/>
      <el-table-column label="实验室负责人" align="center" prop="adminNameAndPhone" show-overflow-tooltip width="180"/>
      <el-table-column label="隐患总数" align="center" prop="dangerNum" show-overflow-tooltip width="100"/>
      <el-table-column label="整改率" align="center" prop="percent" show-overflow-tooltip width="100"/>
      <el-table-column label="复核通过率" align="center" prop="percent2" show-overflow-tooltip width="100"/>
    </el-table>
    <pagination :page-sizes="[20, 30, 40, 50]"
                v-show="total>0"
                :total="total"
                :page.sync="queryParams.pageNum"
                :limit.sync="queryParams.pageSize"
                @pagination="getList"
    />
  </div>
</template>

<script>
  import { listDepartments } from "@/api/system/dept";
  import { listClassifiedAll } from "@/api/laboratory/classified";
  import { listClasstypeAll } from "@/api/laboratory/classtype";
  import { dataStatisticsSubList,dataStatisticsSubListTop } from "@/api/safetyCheck/index";
  export default {
    name: 'laboratoryStatistics',
    data(){
      return{
        deptSelectList:[],
        classTypeList:[],
        classifiedList:[],
        dateRange:[],
        queryParams:{
          pageNum:1,
          pageSize:20,
          searchValue:"",
          deptId:"",
          typeId:"",
          level:""
        },
        setChildren:"",
        numData:{},
        tableList:[],
        total:0,
      }
    },
    created(){

    },
    mounted(){
      this.initializationInterface();
      this.getList();
    },
    methods:{
      initializationInterface(){
        //获取学院列表
        listDepartments().then(response => {
          this.deptSelectList = response.data;
        });
        /**获取分级*/
        listClassifiedAll().then(response=>{
          this.classifiedList = response.data
        })
        /**获取分类*/
        listClasstypeAll().then(response=>{
          this.classTypeList = response.data;
        });
      },
      //获取数据列表
      getList(){
        let obj = JSON.parse(JSON.stringify(this.queryParams))
        if(this.dateRange[0]){
          obj.beginTime = this.dateRange[0];
        }else{
          obj.beginTime = "";
        }
        if(this.dateRange[1]){
          obj.endTime = this.dateRange[1];
        }else{
          obj.endTime = "";
        }
        dataStatisticsSubList(obj).then(response => {
          this.total = response.total;
          this.tableList = response.rows;
        });
        dataStatisticsSubListTop(obj).then(response => {
          this.$set(this,'numData',response.data);
        });
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.$set(this.queryParams,'pageNum',1);
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.$set(this,'dateRange',[]);
        this.$set(this,'queryParams',{
          pageNum:1,
          pageSize:20,
          searchValue:"",
          deptId:"",
          typeId:"",
          level:""
        });
        this.handleQuery();
      },
      /** 导出按钮操作 */
      exportButton(item) {
        let self = this;
        if(item.command == 1){
          self.$confirm(`确认导出全部数据?`, "提示", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(async () => {
            self.download('/zd-security/DataStatistics/subExport/', {}, '实验室统计-.xlsx')
          }).catch(() => {})
        }else if(item.command == 2){
          let list = self.$refs.multipleTable.selection;
          let ids = [];
          for(let i=0;i<list.length;i++){
            ids.push(list[i].subId)
          }
          console.log('list',list);
          console.log('ids',ids);
          if(ids.length>0) {
            self.$confirm(`确认导出选中数据?`, "提示", {
              confirmButtonText: "确定",
              cancelButtonText: "取消",
              type: "warning"
            }).then(async () => {
              self.download(`/zd-security/DataStatistics/subExport/?ids=`+ids,{}, '实验室统计.xlsx')
              this.$refs.multipleTable.clearSelection();
            }).catch(() => {})
          }else {
            this.msgError('请选择要导出的数据')
          }
        }
      },
      /*===记录勾选数据===
        需要再el-table 添加  :row-key="getRowKeys"
        需要在selection 添加 :reserve-selection="true"
      */
      getRowKeys(row) {
        return row.id
      },
      // 单选
      select (selection, row) {
        if (selection.some(el => { return row.id === el.id })) {
          if (row.children) {
            this.setChildren(row.children, true)
          }
        } else {
          if (row.children) {
            this.setChildren(row.children, false)
          }
        }
      },
      // 全选
      selectAll (selection) {
        const isSelect = selection.some(el => {
          const tableDataIds = this.tableData.map(j => j.id)
          return tableDataIds.includes(el.id)
        })
        const isCancel = !this.tableData.every(el => {
          const selectIds = selection.map(j => j.id)
          return selectIds.includes(el.id)
        })
        if (isSelect) {
          selection.map(el => {
            if (el.children) {
              this.setChildren(el.children, true)
            }
          })
        }
        if (isCancel) {
          this.tableData.map(el => {
            if (el.children) {
              this.setChildren(el.children, false)
            }
          })
        }
      },
    }
  }
</script>

<style scoped lang="scss">
  ::v-deep .el-table__fixed{
    margin-top:-1px;
    margin-left:-1px;
    height:100%!important;
  }
  ::v-deep .el-table__fixed-body-wrapper{
    height: calc(100% - 48px);
    overflow-y: auto;
    pointer-events: none;
    cursor: default;
  }
  .laboratoryStatistics{
    flex:1;
    display: flex;
    flex-direction: column;
    overflow: hidden;
    padding:20px;
    .form-box{
      .form-dropdown-box{
        display: flex;
        margin:0;
        padding:0 10px;
        cursor: pointer;
        height:40px;
        img:nth-child(1){
          width:16px;
          height:16px;
          margin-top:12px;
        }
        p{
          width:47px;
          text-align: center;
          font-size:14px;
          margin:0;
          line-height:40px;
        }
        img:nth-child(3){
          width:10px;
          height:6px;
          margin-top:17px;
        }
      }
    }
    .num-data-box{
      background: rgba(1,131,250,0.2);
      color:#0183FA;
      font-size:14px;
      line-height:40px;
      padding:0 20px;
      border-radius:4px;
      margin-bottom:20px;
    }
  }
</style>
